# José David Guillén Domínguez
## Software Engineer
[eMail](mailto://jd@infdj.com) / [WebSite](https://jd.infdj.com) / [Linkedin](https://www.linkedin.com/in/jos%C3%A9-david-guill%C3%A9n-dom%C3%ADnguez-742151a7/) / [Github](https://git.infdj.com)

![jdg](https://git.infdj.com/avatars/f563d8630a2d09c7d6548d7964bf9ccf?size=96)

Experienced software developer and resolutive, able to manage the entire cycle of any software (planning, implementation, testing, documentation, installation and maintenance) to meet customer needs:

* Adaptation to new programming languages and problem solving
* Management capacity, strong analytical and troubleshooting skills
* Clear communication, feedback and necessities
* Organized in development and execution of projects, defining environments and solution

## ⌨ Technical Experience

**Software Engineer** @ [Boyum-IT](https://www.boyum-it.com) (Jan 2016 - present)

* Development and improvent of a manufacturing solution for SAP Business One
* Refactoring of legacy code to clarify, deduplicate and optimize the code following SOLID principles while improving the speed
* Bug finder and fixer for the complex and oldest parts of the application
* Creation of an internal application (PHP) to create reports and display a [public activity log](https://www.beascloud.com/beasweb/tfsActivityLog.php) from data collected directly from our Azure TFS using TFS API and a custom gateways for the pictures extracted from Azure
* Taking requirements, analysis and development of a new framework to rebuild from scratch the old terminal application with the cloud as target. Some of the main challenges have been:
* * Refactoring of legacy code to allow integration without code duplication
* * APIfication of core elements to optimize communications between the core of the application and the new web modules exposing services throw an API/REST service
* * Creation of a new vanilla JS front end framework (due the initial requirements, memory and resources limitation, this was created from scrach with zero depencies and low resources requirements focusing on handheld devices)

**Software Engineer** @ [Informática D.J. programadores](https://www.infdj.com) (1999 - 2016)

* **Developing applications mainly in C / C++ for all sort of areas**, some of the more relevant customers (Atelex, Protección y Electrónica del Sur, Comedores Heineken España, …)
* **Managing AWS servers and CI/CD integration** for the lasted projects in order to optimize the internal resources
* **As internal milestones developed in PHP:**
* * Migration to cloud of the whole company applications, (previously was written using C++ Builder + MySQL) and we ported it to cloud using PHP. After this we create the whole ecommerce and connected it with the PoS
* * Integration with the Amazon APIs to automate received orders (any purchase made by an AMAZON customer triggered all the flow into the internal application, reserving the products, creating the sales documents, updating the stock in the ecommerce/amazon/PoS, etc..)
* * Integration of Amazon APIs to publish and update products, using an adaptive algorithm to increase / decrease prices based on offers from other sellers.
* * Integration of with the providers APIs to keep update the prices and products

### Remarkable projects:

[SGI-ERP.es](https://app.sgi-erp.es) (2010-2015)
> **Could ERP system created as a SaaS using PHP for the backend and JS/HTML/CSS for the front end that runs on a AWS cloud platform, allowing organizations to access over the internet via mobile and/or desktop.** it’s multi-platform and os independent, modular, expandable and it’s able to integrate on all business areas (logistic, production, billing, etc...)


[Agata](https://agata.atelex.com) # { Atelex, S.L. - Servicios para hospitales y empresas } (2011)
> **Could application developed using PHP to manage the maintenance of medical equipment on public hospitals and private clinics**, the app was used by the 13 company’s delegations all over Spain


[Intranet](http://www.protelsur.com) #{Protelsur} (2008-2010)
> **Could application developed using PHP to manage the maintenance, workorders, contracts, orders, invoices, and legal documentation required for private security companies in Spain**, the app wich is currently still active, was developed using PHP for the backend and HTML/JS + JQuery/CSS for the front end. (generation of signed eFactura, banks file export C19, link with SAGE SP for accounting)


[Point of Sale](http://) (1999-2004) 
> **Point of sale, it’s a modular client/server software for touch terminals**, written in C++/MySQL . Some of the customers who required special customizations was “Comedores Heineken España” to read the employees RFID’s card and connect the terminals throw the network to export data to their system.


## 💬 Languages
**Spanish:** Native
**English:** Conversation

**Backend:** C / C++ / CPP Builder / PHP / NodeJS / GoLang
**Frontend:** HTML / CSS / JS / TypeScript / Angular
**Other Languages:** C#, PowerBuilder, MySQL, HANA, Bash Scripting

## ⭐ Certificates
[AZ-900](https://c.infdj.com/s/mLwii3eyTYN5Qx6) Microsoft Azure Fundamentals

## ☕ On the side
Playing with Virtual Enviroments, like AWS and Proxmox installing and testing new releases of software like FreeNas / PfSense / Vesta CP or emerging languages (always using linux distributions)


